<style scoped lang="less">

  @padding-x: 20px;
  @arrow-size: 44px;


  .layout {
    height: 100%;
  }

  header {
    height: var(--header-height);
    display: flex;
    align-items: center;
    padding: 0 @padding-x;
    position: fixed;
    top: 0;
    left: 0;
    width: 100vw;
    background: #fff;
    z-index: 100;

    .arrow {
      width: @arrow-size;
      height: @arrow-size;
      background-color: transparent;
      border: 0;
      outline: none;
      display: flex;
      align-items: center;
      justify-content: center;
      cursor: pointer;
    }


    .title {
      font-size: 18px;
      margin-left: 10px;
      font-weight: 700;
      text-transform: uppercase;
    }
  }

  main {
    height: 100%;
    flex-grow: 1;
    padding: 0 @padding-x;
  }

</style>

<template>

  <div class="layout">

    <header>

      <button class="arrow" @click="$router.back()">

        <img src="~Assets/images/arrow-left.svg" alt="arrow left image"/>

      </button>

      <span class="title">{{ title }}</span>

    </header>

    <main>
      <router-view></router-view>
    </main>

  </div>

</template>

<script>

  import { eventBus }       from 'Core/plugins/event-bus.js'
  import { ScannerActions } from 'Store/modules/scanner'

  import Logo from 'UI/components/logo/logo.vue'

  export default {
    name:       'scanner-layout',
    components: { Logo },
    data() {
      return {
        title: 'Scanning ...',
      }
    },
    methods: {
      setTitle( title ) {
        this.title = title
      }
    },
    created() {
      eventBus.on( ScannerActions.SCANNER_START, () => this.setTitle( 'Scanning...' ) )
      eventBus.on( ScannerActions.SCANNER_DATA_RECEIVED, () => this.setTitle( 'Results' ) )
    },
    destroyed() {
      eventBus.off( ScannerActions.SCANNER_START )
      eventBus.off( ScannerActions.SCANNER_DATA_RECEIVED )
    }
  }

</script>
